#include <iostream>
#include <string>

using namespace std;

const int ALPHABET_SIZE = 26;

void calculateWordsAndFreq(string line, int freq[]);

void printArray(int arr[], int size);

int main() {
    cout << "Please enter a line of text:\n";
    string line;
    getline(cin, line);

    int freq[ALPHABET_SIZE] = {0};

    // Indices of `freq` represent the location of every letter in alphabet
    // and the value of each element represents how many times a letter appears in `line`
    calculateWordsAndFreq(line, freq);

    printArray(freq, ALPHABET_SIZE);
    return 0;
}

void calculateWordsAndFreq(string line, int freq[]) {
    int cnt_words = 0, start = 0;
    for (int i = 0; i <= line.length(); ++i) {
        if (i >= line.length() || line[i] == ' ' || line[i] == ',' || line[i] == '.') {
            if (i - start > 0) {
                ++cnt_words;
            }
            start = i + 1;
        } else if (islower(line[i])) { ++freq[int(line[i]) - int('a')]; }
        else if (isupper(line[i])) { ++freq[int(line[i]) - int('A')]; }
    }
    cout << cnt_words << "\twords\n";
}

void printArray(int arr[], int size) {
    for (int i = 0; i < size; ++i) {
        if (arr[i] > 0) {
            cout << arr[i] << "\t" << (char) (i + (int) 'a') << endl;
        }
    }
}