#include <iostream>
#include <cassert>

using namespace std;

int *getPosNums1(int *arr, int arrSize, int &outPosArrSize);

int *getPosNums2(int *arr, int arrSize, int *outPosArrSizePtr);

void getPosNums3(int *arr, int arrSize, int *&outPosArr, int &outPosArrSize);

void getPosNums4(int *arr, int arrSize, int **outPosArrPtr, int *outPosArrSizePtr);

bool arrayEqual(int arr[], int expectedArr[], int size);

int main() {

    int arrSize = 6;
    int arr[6] = {3, -1, -3, 0, 6, 4};

    int expectedArr[3] = {3, 6, 4};
    int expectedSize = 3;

    cout << "Test case:\n"
         << "Input: {3, -1, -3, 0, 6, 4};\n"
         << "Expected ouput: {3, 6, 4}, size = 3\n"
         << "==========================\n";

    // Test getPosNums1()
    int outPosArrSize1;
    int *newArr1 = getPosNums1(arr, arrSize, outPosArrSize1);
    assert(outPosArrSize1 == expectedSize && "Wrong size returned for getPosNums1()");
    assert(arrayEqual(newArr1, expectedArr, outPosArrSize1) && "Wrong array returned for getPosNums1()");
    cout << "getPosNums1() -- Test passed\n==========================\n";

    // Test getPosNums2()
    int outPosArrSize2;
    int *newArr2 = getPosNums2(arr, arrSize, &outPosArrSize2);
    assert(outPosArrSize2 == expectedSize && "Wrong size returned for getPosNums2()");
    assert(arrayEqual(newArr2, expectedArr, outPosArrSize2) && "Wrong array returned for getPosNums2()");
    cout << "getPosNums2() -- Test passed\n==========================\n";

    //Test getPosNums3()
    int outPosArrSize3;
    int *newArr3;
    getPosNums3(arr, arrSize, *&newArr3, outPosArrSize3);
    assert(outPosArrSize3 == expectedSize && "Wrong size returned for getPosNums3()");
    assert(arrayEqual(newArr3, expectedArr, outPosArrSize3) && "Wrong array returned for getPosNums3()");
    cout << "getPosNums3() -- Test passed\n==========================\n";


    //Test getPosNums4()
    int outPosArrSizePtr4;
    int *newArr4;
    getPosNums4(arr, arrSize, &newArr4, &outPosArrSizePtr4);
    assert(outPosArrSizePtr4 == expectedSize && "Wrong size returned for getPosNums4()");
    assert(arrayEqual(newArr4, expectedArr, outPosArrSizePtr4) && "Wrong array returned for getPosNums4()");
    cout << "getPosNums4() -- Test passed\n==========================\n";


    delete[] newArr1;
    delete[] newArr2;
    delete[] newArr3;
    delete[] newArr4;

    newArr1 = nullptr;
    newArr2 = nullptr;
    newArr3 = nullptr;
    newArr4 = nullptr;

    return 0;
}

int *getPosNums1(int *arr, int arrSize, int &outPosArrSize) {
    outPosArrSize = 0;
    int *newArr = new int[arrSize];
    for (int i = 0; i < arrSize; ++i) {
        if (arr[i] > 0) {
            newArr[outPosArrSize] = arr[i];
            ++outPosArrSize;
        }
    }
    return newArr;
}

int *getPosNums2(int *arr, int arrSize, int *outPosArrSizePtr) {
    *outPosArrSizePtr = 0;
    int *newArr = new int[arrSize];
    for (int i = 0; i < arrSize; ++i) {
        if (arr[i] > 0) {
            newArr[*outPosArrSizePtr] = arr[i];
            ++(*outPosArrSizePtr);
        }
    }
    return newArr;
}

void getPosNums3(int *arr, int arrSize, int *&outPosArr, int &outPosArrSize) {
    outPosArrSize = 0;
    outPosArr = new int[arrSize];
    for (int i = 0; i < arrSize; ++i) {
        if (arr[i] > 0) {
            outPosArr[outPosArrSize] = arr[i];
            ++outPosArrSize;
        }
    }
}

void getPosNums4(int *arr, int arrSize, int **outPosArrPtr, int *outPosArrSizePtr) {
    *outPosArrSizePtr = 0;
    *outPosArrPtr = new int[arrSize];
    for (int i = 0; i < arrSize; ++i) {
        if (arr[i] > 0) {
            (*outPosArrPtr)[*outPosArrSizePtr] = arr[i];
            ++(*outPosArrSizePtr);
        }
    }
}

bool arrayEqual(int arr[], int expectedArr[], int size) {
    for (int i = 0; i < size; ++i) {
        if (arr[i] != expectedArr[i]) return false;
    }
    return true;
}