#include <iostream>
#include <cassert>

using namespace std;

void oddsKeepEvensFlip(int arr[], int arrSize);

void swapNumbers(int &num1, int &num2);

bool arrEqual(int arr[], int expectedArr[], int size);

int main() {
    // Test cases
    int arr1[6] = {5, 2, 11, 7, 6, 4};
    int arr2[6] = {5, 21, 8, 7, 6, 3};
    int arr3[6] = {10, 4, 1, 6, 5, 7};
    int arrSize = 6;

    oddsKeepEvensFlip(arr1, arrSize);
    oddsKeepEvensFlip(arr2, arrSize);
    oddsKeepEvensFlip(arr3, arrSize);

    int expectedArr1[6] = {5, 11, 7, 4, 6,2};
    int expectedArr2[6] = {5, 21, 7, 3, 6, 8};
    int expectedArr3[6] = {1, 5, 7, 6, 4, 10};
    bool isEqual1 = arrEqual(arr1, expectedArr1, arrSize);
    bool isEqual2 = arrEqual(arr2, expectedArr2, arrSize);
    bool isEqual3 = arrEqual(arr3, expectedArr3, arrSize);


    assert(isEqual1 && "wrong result1 for {5, 2, 11, 7, 6, 4}");
    cout << "Test1 passed -- {5, 2, 11, 7, 6, 4} -> {5, 11, 7, 4, 6,2}\n";
    assert(isEqual2 && "wrong result2 for {5, 21, 8, 7, 6, 3}");
    cout << "Test2 passed -- {5, 21, 8, 7, 6, 3} -> {5, 21, 7, 3, 6, 8}\n";
    assert(isEqual3 && "wrong result3 for {10, 4, 1, 6, 5, 7}");
    cout << "Test3 passed -- {10, 4, 1, 6, 5, 7} -> {1, 5, 7, 6, 4, 10}\n";

    return 0;
}

void oddsKeepEvensFlip(int arr[], int arrSize) {
    int odd = 0, even = arrSize - 1;
    int* newArr = new int[arrSize];

    for (int i = 0; i < arrSize; ++i) {
        if (arr[i] % 2 == 1) {
            newArr[odd++] = arr[i];
        } else {
            newArr[even--] = arr[i];
        }
    }

    for (int i=0; i<arrSize;++i){
        arr[i] = newArr[i];
    }

    delete[] newArr;
    newArr = nullptr;
}

bool arrEqual(int arr[], int expectedArr[], int size) {
    for (int i = 0; i < size; ++i) {
        if (arr[i] != expectedArr[i]) return false;
    }
    return true;
}